// demo2Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "demo2.h"
#include "demo2Dlg.h"

#include "nr.h"
#include "nrutil.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemo2Dlg dialog

CDemo2Dlg::CDemo2Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemo2Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemo2Dlg)
	m_edit_input = _T("");
	m_edit_output = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemo2Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemo2Dlg)
	DDX_Text(pDX, IDC_EDIT_INPUT2, m_edit_input);
	DDX_Text(pDX, IDC_EDIT_OUTPUT, m_edit_output);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemo2Dlg, CDialog)
	//{{AFX_MSG_MAP(CDemo2Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_OPEN, OnButtonOpen)
	ON_BN_CLICKED(IDC_BUTTON_SVD, OnButtonSvd)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemo2Dlg message handlers

BOOL CDemo2Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	CWnd *pWnd;
	pWnd=GetDlgItem(IDC_BUTTON_SVD);
	pWnd->EnableWindow(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDemo2Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CDemo2Dlg::OnDestroy()
{
	WinHelp(0L, HELP_QUIT);
	CDialog::OnDestroy();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDemo2Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDemo2Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDemo2Dlg::OnButtonOpen() 
{
	CFileDialog FileDlg(TRUE, NULL, NULL, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY,
	_T("Matrix data files(*.mdf)|*.mdf|All files (*.*)|*.*||"), NULL);
	if(FileDlg.DoModal() == IDOK)
	{

		CFile	XFile;
		CString buffstring,buffstring2;
		
		if(XFile.Open(FileDlg.GetPathName(),CFile::modeRead|CFile::shareDenyNone))
		{
			CArchive FArchive(&XFile,CArchive::load);
			FArchive.ReadString(buffstring);
			buffstring.MakeUpper();
			if (buffstring=="MATRIX DATA FILE")
			{
				FArchive.ReadString(buffstring);
				Matrix_row=atoi(LPCSTR(buffstring));
				FArchive.ReadString(buffstring);
				Matrix_column=atoi(LPCSTR(buffstring));
				
				long i,j,nextspace;
				ORIGINAL_MATRIX=matrix(1,Matrix_row,1,Matrix_column);
				for(i=1;i<=Matrix_row;i++)
				{
					FArchive.ReadString(buffstring);
					for(j=1;j<=Matrix_column;j++)
					{
						nextspace = buffstring.FindOneOf("	 ");
						if(nextspace==-1){nextspace=buffstring.GetLength();}
						buffstring2=buffstring.Left(nextspace);
						buffstring=buffstring.Mid(nextspace);
						buffstring.TrimLeft();
						ORIGINAL_MATRIX[i][j]=(float)atof(LPCSTR(buffstring2));
					}
				}

				CWnd *pWnd;
				pWnd=GetDlgItem(IDC_BUTTON_SVD);
				pWnd->EnableWindow(TRUE);
			}
			else
			{
				AfxMessageBox(" It is not a matrix data file.");
			}
			FArchive.Close();
			XFile.Close();

			XFile.Open(FileDlg.GetPathName(),CFile::modeRead|CFile::shareDenyNone);
			char *charbuffer = new char[XFile.GetLength()+1];
			charbuffer[XFile.GetLength()]=0;
			XFile.Read(charbuffer,XFile.GetLength());
			m_edit_input=CString(charbuffer);//+"\r\n/0";
			UpdateData(FALSE);

			XFile.Close();
			delete charbuffer;
		}
		else
		{
			AfxMessageBox("File open error.");
		}
	}
}

void CDemo2Dlg::OnButtonSvd() 
{
	long k,l;
	float *w,**u,**v;
	
	w=vector(1,Matrix_column);
	u=matrix(1,Matrix_row,1,Matrix_column);
	v=matrix(1,Matrix_column,1,Matrix_column);

	/* copy original matrix into u */
	for (k=1;k<=Matrix_row;k++)
		for (l=1;l<=Matrix_column;l++) 
		{
			u[k][l]=ORIGINAL_MATRIX[k][l];
		}

	/* perform decomposition */
	svdcmp(u,Matrix_row,Matrix_column,w,v);

	CString SVDresultFile="SVDresult.mdf";

	CString buffstring,buffstring2;
	CFile OutputFile;
	OutputFile.Open(SVDresultFile,CFile::modeWrite|CFile::modeCreate);
	CArchive FArchive(&OutputFile,CArchive::store);

	buffstring="MATRIX DATA FILE\r\n";
	FArchive.WriteString(buffstring);
	buffstring="\r\n\r\n#U matrix:\r\n#Matrix row: Matrix column:\r\n";
	FArchive.WriteString(buffstring);
	buffstring.Format("%d           %d \r\n",Matrix_row,Matrix_column);
	FArchive.WriteString(buffstring);

	long i,j;
	for(i=1;i<=Matrix_row;i++)
	{
		buffstring=CString(" ");
		for(j=1;j<=Matrix_column;j++)
		{
			buffstring2.Format("%f",u[i][j]);
			buffstring=buffstring+"  "+buffstring2;
		}
		buffstring=buffstring+"\r\n";
		FArchive.WriteString(buffstring);
	}

	buffstring="\r\n\r\n#D diagonal:\r\n#Length of diagonal:\r\n";
	FArchive.WriteString(buffstring);
	buffstring.Format("%d\r\n",Matrix_column);
	FArchive.WriteString(buffstring);

	buffstring=CString(" ");
	for(j=1;j<=Matrix_column;j++)
	{
		buffstring2.Format("%f",w[j]);
		buffstring=buffstring+"  "+buffstring2;
	}
	FArchive.WriteString(buffstring);

	buffstring="\r\n\r\n#V matrix:\r\n#Matrix row: Matrix column:\r\n";
	FArchive.WriteString(buffstring);
	buffstring.Format("%d           %d \r\n",Matrix_column,Matrix_column);
	FArchive.WriteString(buffstring);

	for(i=1;i<=Matrix_column;i++)
	{
		buffstring=CString(" ");
		for(j=1;j<=Matrix_column;j++)
		{
			buffstring2.Format("%f",v[i][j]);
			buffstring=buffstring+"  "+buffstring2;
		}
		buffstring=buffstring+"\r\n";
		FArchive.WriteString(buffstring);
	}

	FArchive.Flush();
	FArchive.Close();
	OutputFile.Close();

	OutputFile.Open(SVDresultFile,CFile::modeRead|CFile::shareDenyNone);
	char *charbuffer = new char[OutputFile.GetLength()+1];
	charbuffer[OutputFile.GetLength()]=0;
	OutputFile.Read(charbuffer,OutputFile.GetLength());
	m_edit_output=CString(charbuffer);//+"\r\n/0";
	UpdateData(FALSE);

	OutputFile.Close();
	delete charbuffer;

	CWnd *pWnd;
	pWnd=GetDlgItem(IDC_BUTTON_SVD);
	pWnd->EnableWindow(FALSE);

}
